<?php
/*
=====================================================
	ExpressionEngine - by Denik
-----------------------------------------------------
	http://denik.od.ua/
-----------------------------------------------------
	Copyright (c) 2008 - 2009 Denik, Inc.
-----------------------------------------------------
	Version:		1.0
-----------------------------------------------------
	Compatibility:	EE 1.6.7
-----------------------------------------------------
	Updated:		2010-04-03
=====================================================
File: mcp.dc_gallery.php
=====================================================
*/

if ( ! defined('EXT'))
{
    exit('Invalid file request');
}

class Dc_gallery_CP {

    var $version        = '1.0 Alpha 2';
    var $settings		= array();

    // -------------------------
    //  Constructor
    // -------------------------
    function Dc_gallery_CP ($switch = TRUE)
    {
        global $IN, $DB, $DSP, $LANG, $PREFS;
		
		$DSP->title = $LANG->line('dc_gallery_module_name');
        if ($switch)
        {
			// Load Configs
			$this->load_config();
			
            switch($IN->GBL('P'))
            {
                case 'configs'      : $this->configs();
                     break;
                case 'modify_s'     : $this->modify_s();
                     break;
                case 'recreate'     : $this->recreate();
                     break;
                default             : $this->home();
                     break;
            }
        }
    }
    // END

    // ----------------------------------------
    //  Чанк меню
    // ----------------------------------------
	function chunk_menu($open = 1)
	{
		GLOBAL $DSP, $LANG, $IN;
		
		if( $open != 1 )
		{
			$DSP->body .= $DSP->td_c()
					 .$DSP->tr_c()
					 .$DSP->table_c();
			return;
		}
		
		$DSP->body .= $DSP->table('', '', '', '100%').
				$DSP->tr().
				$DSP->td('templateEditBox', '20%', '', '', 'top').
				"<div class='tableHeadingAlt'><span style='float:right;color:#999999;'>by Denik</span><b>".$LANG->line('dc_gallery_module_name')." ".$this->version."</b></div>";
		$DSP->body .= $DSP->div('templateprefpad').$DSP->div('leftPad');
		$DSP->body .= $DSP->qdiv('itemWrapper', $DSP->anchor(BASE.AMP.'C=modules'.
															AMP.'M=Dc_gallery', 
															$LANG->line('home_page')), "", (( !$IN->GBL('P') || strstr($IN->GBL('P'),'Manage') )?"style='font-weight:bold;'":"") );
		$DSP->body .= $DSP->qdiv('itemWrapper', $DSP->anchor(BASE.AMP.'C=modules'.
															AMP.'M=Dc_gallery'.
															AMP.'P=configs', 
															$LANG->line('configs')), "", ((strstr($IN->GBL('P'),'configs'))?"style='font-weight:bold;'":""));
		$DSP->body .= $DSP->qdiv('itemWrapper', $DSP->anchor(BASE.AMP.'C=modules'.
															AMP.'M=Dc_gallery'.
															AMP.'P=documentation', 
															$LANG->line('documentation')));
		$DSP->body .= $DSP->qdiv('itemWrapper', $DSP->anchor(BASE.AMP.'C=modules'.
															AMP.'M=Dc_gallery'.
															AMP.'P=recreate', 
															$LANG->line('recreate_thumbs')), "", ((strstr($IN->GBL('P'),'recreate'))?"style='font-weight:bold;'":""));
		$DSP->body .= $DSP->div_c().$DSP->div_c();
		$DSP->body .= $DSP->td_c()
				 .$DSP->td('defaultSmall', '1%').NBS;
		$DSP->body .= $DSP->td_c()
				 .$DSP->td('', '79%', '', '', 'top');
	}

    
    // ----------------------------------------
    //  Выводит общую статистику
    // ----------------------------------------
    function home()
    {
		global $DSP, $LANG, $DB, $IN, $PREFS;
		
		// Вывод лог. структуры
        $DSP->crumb = $DSP->anchor(BASE.
                                   AMP.'C=modules'.
                                   AMP.'M=Testing',
                                   $LANG->line('testing_module_name'));
        $DSP->crumb .= $DSP->crumb_item($LANG->line('test_list'));
        
		$this->chunk_menu();
        
		// Кнопка "Создать тест":
		$DSP->body .= $DSP->right_crumb("Создать тест",
										BASE.AMP.'C=modules'.
										AMP.'M=Testing'.
										AMP.'P=ManageTest', 
										'', FALSE);
										
        // Поиск -->
        $DSP->body .= $DSP->qdiv('tableHeading', "Поиск по параметрам");
     /*   $param = "Название: ".$DSP->input_text('title', $IN->GBL('title'), 0, 255, '', '100px');
        
		$param .= " &nbsp; ".$DSP->input_select_header('cat_id')."<option value=''>Категория</option><option value=''>- -</option>";
		if ( ! class_exists('Publish'))
		{
			require PATH_CP.'cp.publish'.EXT;
		}
		$PUB = new Publish();
		if( ! isset($this->config["cat_groups"]) || sizeof($this->config["cat_groups"])==0 )
		{
			$this->config["cat_groups"] = Array();
			$g = $DB->query("SELECT group_id FROM exp_category_groups");
			foreach($g->result as $row) $this->config["cat_groups"][]=$row['group_id'];
		}
		foreach( $this->config["cat_groups"] as $group )
		{
			if(isset($c)&&$c=='1') $param .= "<option value=''>- -</option>";
			$c = '1';
			$PUB->categories = Array();
			if( $IN->GBL('cat_id') ) $PUB->category_tree($group, 'edit', '', Array($IN->GBL('cat_id')));
			else $PUB->category_tree($group);
			for($i=1; $i<count($PUB->categories)-1;$i++)
			{
				$param .= (isset($this->config["parent_only"]) && $this->config["parent_only"]) ? ((!strstr($PUB->categories[$i],"&nbsp;&nbsp;&nbsp;"))?$PUB->categories[$i]:"") : $PUB->categories[$i];
			}
		}
		$param .= $DSP->input_select_footer();
		
		$param .= " &nbsp; <input type='submit' value='Поиск' />";
        $act = BASE.AMP.'C=modules'.AMP.'M=Testing';
        $DSP->body .= $DSP->qdiv('box', "<form action='$act' method='post'>".$param."</form>");
        
		$sql_where = ""; $sql_table = "";
        if( $IN->GBL('title') ) $sql_where .= " AND t.title LIKE '%".$IN->GBL('title')."%'";
        if( $IN->GBL('cat_id') )
		{
			$sql_table .= " INNER JOIN exp_testing_cat as tc ON tc.test_id=t.id";
			$sql_where .= " AND tc.cat_id='".$IN->GBL('cat_id')."'";
		}
        // <--
        
        // Заголовок таблицы
		$DSP->body .= $DSP->qdiv('tableHeading', $LANG->line('test_list'));
		
		// Основная таблица
		$DSP->body .= $DSP->table_open(array('class' => "tableBorder", 'width' => "100%"));
		$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => "tableHeadingAlt", 'width'=>"1%", 'text' => "id"),
				'cell2' => array('class' => "tableHeadingAlt", 'text' => "Название"),
				'cell3' => array('class' => "tableHeadingAlt", 'text' => "Краткое имя"),
				'cell4' => array('class' => "tableHeadingAlt", 'text' => "Привязанные категории"),
				'cell5' => array('class' => "tableHeadingAlt", 'text' => "&nbsp", 'colspan' => "2"),
				));

		// Pagination prefs:
		$all_count = $DB->query("SELECT count(t.id) as count FROM exp_testing as t $sql_table WHERE 1=1 $sql_where");
		$all_count = $all_count->row['count'];
		$page = ( ! $IN->GBL('page')) ? 0 : $IN->GBL('page');
		$page_rows = 20;

		$test = $DB->query("SELECT t.id, t.title, t.url_title FROM exp_testing as t $sql_table WHERE 1=1 $sql_where ORDER BY t.id, t.title ASC LIMIT $page, $page_rows");
		if( $test->num_rows > 0 )
		{
			foreach( $test->result as $i=>$row )
			{
				$cat = $DB->query("SELECT c.cat_name FROM exp_testing_cat as tc INNER JOIN exp_categories as c ON c.cat_id=tc.cat_id WHERE tc.test_id='{$row['id']}'");
				
				$c = "";
				foreach( $cat->result as $id=>$item )
				{
					$c .= $DSP->qspan('defaultBold', $item['cat_name']);
					$c .= ($id<$cat->num_rows-1)?",":"";
				}
				if($c=="") $c="- -";
				
				$class = ($i % 2) ? "tableCellOne" : "tableCellTwo";
				$DSP->body .= $DSP->table_row(array(
						'cell1' => array('class'  => $class,
										 'text' => $DSP->qspan('defaultBold', $row['id'])),
						'cell2' => array('class'  => $class, 'text' => $DSP->qspan('defaultBold', $DSP->anchor(BASE.
		                               						AMP.'C=modules'.
		                               						AMP.'M=Testing'.
		                               						AMP.'P=ManageQuestion'.
															AMP.'ID='.$row['id'],
		                               						$row['title'])) ),
						'cell3' => array('class'  => $class, 'text' => $DSP->qspan('default', $row['url_title'] )),
						'cell4' => array('class'  => $class, 'text' => $DSP->qspan('default', $c )),
						'cell5' => array('class'  => $class,
										 'text' => $DSP->qspan('defaultBold', $DSP->anchor(BASE.
		                               						AMP.'C=modules'.
		                               						AMP.'M=Testing'.
		                               						AMP.'P=ManageTest'.
															AMP.'ID='.$row['id'],
		                               						"(изменить)"))), 
						'cell6' => array('class'  => $class,
										 'text' => $DSP->qspan('defaultBold', $DSP->anchor(BASE.
		                               						AMP.'C=modules'.
		                               						AMP.'M=Testing'.
		                               						AMP.'P=DeleteTest'.
															AMP.'ID='.$row['id'],
		                               						"удалить", "onclick=\"return confirm('Удалить этот тест?');\""))), 
													));
			}
		}
		else
		{
			$class = (0 % 2) ? "tableCellOne" : "tableCellTwo";
			$DSP->body .= $DSP->table_row(array(
					'cell1' => array('class'  => $class, 'text' => "тесты не найдены", 'colspan'=>"6")));
		}
				
		// Закрытие таблицы
		$DSP->body .= $DSP->table_close(FALSE);

		$url = BASE.AMP.'C=modules'.AMP.'M=Testing';
		$url .= $IN->GBL('title')?AMP.'title='.$IN->GBL('title'):"";
		$url .= $IN->GBL('cat_id')?AMP.'cat_id='.$IN->GBL('cat_id'):"";
		$DSP->body .= $DSP->qdiv('itemWrapper', $DSP->pager($url,
									  		$all_count, // Всего строк
									  		$page_rows, // Разбиение по...
									  		$page,  // Текущая
									  		'page'
											));
		*/ $DSP->body .= "sdsdsd";
		$this->chunk_menu(0);
    }

	// ----------------------------------------
    //  Пересоздает эскизы
    // ----------------------------------------
	function recreate()
	{
		global $DSP, $LANG, $DB, $IN, $PREFS;
		
		// Вывод лог. структуры
        $DSP->crumb = $DSP->anchor(BASE.
                                   AMP.'C=modules'.
                                   AMP.'M=Testing',
                                   $LANG->line('testing_module_name'));
        $DSP->crumb .= $DSP->crumb_item("Пересоздание эскизов");
        
		$this->chunk_menu();
        
		
		/** Include Image Library */
		require PATH_CORE.'core.image_lib'.EXT;
		$IM = new Image_lib();
		//$IM->resize_protocol = 'imagemagick';  	// Can be:  imagemagick, netpbm, gd, gd2
        
        if( $IN->GBL('ACT')=='thumb' )
        {
        	$imgs = $DB->query("SELECT dg.entry_id, w.weblog_id, w.blog_name, dg.filename, dg.filename_thumb FROM exp_dc_gallery AS dg LEFT JOIN exp_weblogs as w ON dg.weblog_id=w.weblog_id WHERE w.site_id='".$PREFS->ini('site_id')."'");
        	set_time_limit(300);
        	foreach( $imgs->result as $row )
        	{
				/** Upload Path */
				$path = $this->config('upload_path');
				$path = str_replace(LD.'weblog_id'.RD, $row['weblog_id'], $path); // {weblog_id}
				$path = str_replace(LD.'entry_id'.RD, $row['entry_id'], $path); // {entry_id}
				$path = str_replace(LD.'blog_name'.RD, $row['blog_name'], $path); // {blog_name}
				/// /home/baulotr1/public_html/baulot-luxury/uploads/catalog/283/
				
				
				// Upload & Resize Thumb foto 
				if( ($this->conf('thumb_w')>0 || $this->conf('thumb_h')>0) && $this->conf('thumb_name')!='' )
				{
					// Copy source to temp
					$tmp = 'tmp_'.md5($row['filename'].time());
					$i = 0;
					while( file_exists($path.$tmp) ) {$tmp = 'tmp_'.md5($row['filename'].time().$i); $i++;}
					copy($path.$row['filename'], $path.$tmp);
					
					$vals = $IM->get_image_properties($path.$tmp, TRUE);
					
					$new_name = $row['filename_thumb'];
					$new_w = $this->conf('thumb_w') ? $this->conf('thumb_w'): ceil($vals['width']/($vals['height']/$this->conf('thumb_h')));
					$new_h = $this->conf('thumb_h') ? $this->conf('thumb_h'): ceil($vals['height']/($vals['width']/$this->conf('thumb_w')));
					$wh_param['thumb'] = array($new_w, $new_h);
					
					// No resize small images ?
					if( $this->conf('thumb_no_resize_up') && $vals['width']<$new_w && $vals['height']<$new_h )
					{
						$new_w = $vals['width'];
						$new_h = $vals['height'];
					}

					// Crop ?
					if( $this->conf('thumb_crop') )
					{
						$new_h = ceil($vals['height']/($vals['width']/$new_w));
						if( $new_h < $this->conf('thumb_h') )
						{
							$new_h = $this->conf('thumb_h');
							$new_w = ceil($vals['width']/($vals['height']/$new_h));
						}
						$wh_param['thumb'] = array($this->conf('thumb_w'), $this->conf('thumb_h'));
					}

					$res = $IM->set_properties(
										array(
											'full_src_path'		=> $path.$tmp,
											'full_dst_path'		=> $path.$new_name,
											'image_type'		=> $vals['image_type'],
											'new_file_name'		=> $new_name,
											'quality'			=> '80',
											'src_width'			=> $vals['width'],
											'src_height'		=> $vals['height'],
											'dst_width'			=> $new_w,
											'dst_height'		=> $new_h
											)
										);
					if( ! $IM->image_resize() ) foreach( $IM->error_msg as $err ) if( !in_array("<b>$new_name</b>: $err", $errors) ) $errors[] = "<b>$new_name</b>: $err";
					if( $this->conf('thumb_crop') ) // Crop ?
					{
						$IM->full_src_path = $path.$new_name;
						$IM->src_width = $new_w;
						$IM->src_height = $new_h;
						$IM->dst_width = $this->conf('thumb_w') ? $this->conf('thumb_w'): ceil($vals['width']/($vals['height']/$this->conf('thumb_h')));
						$IM->dst_height = $this->conf('thumb_h') ? $this->conf('thumb_h'): ceil($vals['height']/($vals['width']/$this->conf('thumb_w')));
						$IM->x_axis = 0;//floor(($new_w / 2) - ($this->conf('thumb_w') / 2));
						$IM->wm_hor_alignment = 'C';
						if( ! $IM->image_crop() ) foreach( $IM->error_msg as $err ) if( !in_array("<b>$new_name</b>: $err", $errors) ) $errors[] = "<b>$new_name</b>: $err";
					}
					
					// Remove temp file
					unlink($path.$tmp);
				}
        	}
        	
			$DSP->body .= $DSP->qdiv('box', $DSP->qdiv('itemWrapper', $DSP->qdiv('success', "Эскизы thumb пересозданы")));
		}
        
        $DSP->body .= $DSP->qdiv('tableHeading', "Пересоздание эскизов");
		$DSP->body .= $DSP->anchor(BASE.AMP.'C=modules'.
									AMP.'M=Dc_gallery'.
									AMP.'P=recreate'.AMP.'ACT=thumb', 
									"Пересоздать эскизы Thumb");
		$this->chunk_menu(0);
	}

	// ----------------------------------------
    //  Настройки
    // ----------------------------------------
    function conf($field) {return $this->config($field);}
    function config($field)
    {
		GLOBAL $PREFS;
		return isset($this->settings[$PREFS->ini('site_id')][$field])?$this->settings[$PREFS->ini('site_id')][$field]:false;
	}
	function load_config()
    {
    	GLOBAL $DB;
		$res = $DB->query("SELECT settings FROM exp_extensions WHERE class='Dc_gallery_ext' LIMIT 0,1");
		$this->settings = @unserialize($res->row['settings']);
	}
	function configs()
	{
		global $DSP, $LANG, $DB, $IN, $PREFS;
		
		// Вывод лог. структуры
        $DSP->crumb = $DSP->anchor(BASE.
                                   AMP.'C=modules'.
                                   AMP.'M=Testing',
                                   $LANG->line('testing_module_name'));
        $DSP->crumb .= $DSP->crumb_item($LANG->line('configs'));
		$this->chunk_menu();
        
        $site_id = $PREFS->ini('site_id');
        
        if( $IN->GBL('save') )
        {
        	$this->settings[$site_id]['cat_groups'] = $IN->GBL('cat_groups', 'POST');
			$this->settings[$site_id]['weblogs'] = $IN->GBL('weblogs', 'POST');
			$this->settings[$site_id]['label'] = $IN->GBL('label', 'POST');
			$this->settings[$site_id]['upload_path'] = $IN->GBL('upload_path', 'POST');
			$this->settings[$site_id]['upload_url'] = $IN->GBL('upload_url', 'POST');
			$this->settings[$site_id]['orig_w'] = $IN->GBL('orig_w', 'POST');
			$this->settings[$site_id]['orig_h'] = $IN->GBL('orig_h', 'POST');
			$this->settings[$site_id]['medium_w'] = $IN->GBL('medium_w', 'POST');
			$this->settings[$site_id]['medium_h'] = $IN->GBL('medium_h', 'POST');
			$this->settings[$site_id]['thumb_w'] = $IN->GBL('thumb_w', 'POST');
			$this->settings[$site_id]['thumb_h'] = $IN->GBL('thumb_h', 'POST');
			$this->settings[$site_id]['medium_name'] = $IN->GBL('medium_name', 'POST');
			$this->settings[$site_id]['thumb_name'] = $IN->GBL('thumb_name', 'POST');
			$this->settings[$site_id]['orig_crop'] = $IN->GBL('orig_crop', 'POST')?true:false;
			$this->settings[$site_id]['medium_crop'] = $IN->GBL('medium_crop', 'POST')?true:false;
			$this->settings[$site_id]['thumb_crop'] = $IN->GBL('thumb_crop', 'POST')?true:false;
			$this->settings[$site_id]['orig_no_resize_up'] = $IN->GBL('orig_no_resize_up', 'POST')?true:false;
			
			$DB->query("UPDATE exp_extensions SET settings='".serialize($this->settings)."' WHERE class='Dc_gallery_ext'");
			$DSP->body .= $DSP->qdiv('box', $DSP->qdiv('itemWrapper', $DSP->qdiv('success', $LANG->line('conf_saved'))));
		}
        
        // Заголовок таблицы
		$DSP->body .= $DSP->qdiv('tableHeading', $LANG->line('configs'));
		
		$DSP->body .= $DSP->form('C=modules'.AMP.'M=Dc_gallery'.AMP.'P=configs', "configform");
		// Основная таблица
		$DSP->body .= $DSP->table_open(array('class' => "tableBorder", 'width' => "100%", 'valign' => "top"));
		$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => "tableHeadingAlt", 'width'=>"30%", 'text' => $LANG->line('conf_conf')),
				'cell2' => array('class' => "tableHeadingAlt", 'text' => $LANG->line('conf_val')),
				));
		$class = (0 % 2) ? "tableCellOne" : "tableCellTwo";
		$input_style = "295px;border:1px solid #CCCCCC;";
		$input_style_wh = "80px;border:1px solid #CCCCCC;";
		
	/*hr*/$DSP->body .= $DSP->table_row(array('cell1' => array('text' => "&nbsp;",'colspan'=>"2")));
		$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => "tableHeading", 'width'=>"30%", 'text' => $LANG->line('general_conf')),
				'cell2' => array('class' => "tableCellTwo", 'text' => "",'colspan'=>"1"),
				));				
		// CAT GROUPS
		$g = $DB->query("SELECT group_id, group_name FROM exp_category_groups WHERE site_id='$site_id'");
		$field = $DSP->input_select_header('cat_groups[]', "milti", 5);
		$field .= $DSP->input_select_option(0, $LANG->line('none'), '');
		foreach( $g->result as $row ) $field .= $DSP->input_select_option($row['group_id'], $row['group_name'], ($this->config('cat_groups') && in_array($row['group_id'], $this->config('cat_groups')))?'1':'');
		$field .= $DSP->input_select_footer();
		$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => $class, 'text' => $DSP->qdiv('defaultBold', $LANG->line('catgroups')).$LANG->line('catgroups_desc')),
				'cell2' => array('class' => $class, 'text' => $DSP->qspan('default', $field)),
											));
		// Weblogs
		$g = $DB->query("SELECT weblog_id, blog_title FROM exp_weblogs WHERE site_id='$site_id'");
		$field = $DSP->input_select_header('weblogs[]', "milti", 5);
		$field .= $DSP->input_select_option(0, $LANG->line('none'), '');
		foreach( $g->result as $row ) $field .= $DSP->input_select_option($row['weblog_id'], $row['blog_title'], ($this->config('weblogs') && in_array($row['weblog_id'], $this->config('weblogs')))?'1':'');
		$field .= $DSP->input_select_footer();
		$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => $class, 'text' => $DSP->qdiv('defaultBold', $LANG->line('weblogs')).$LANG->line('weblogs_desc')),
				'cell2' => array('class' => $class, 'text' => $DSP->qspan('default', $field)),
											));
		// LABEL
		$field = $DSP->input_text('label', ($this->config('label'))?$this->config('label'):$LANG->line('images'), null, null, null, $input_style);
		$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => $class, 'text' => $DSP->qdiv('defaultBold', $LANG->line('label')).$LANG->line('label_desc')),
				'cell2' => array('class' => $class, 'text' => $DSP->qspan('default', $field)),
											));

	/*hr*/$DSP->body .= $DSP->table_row(array('cell1' => array('text' => "&nbsp;",'colspan'=>"2")));
		$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => "tableHeading", 'width'=>"30%", 'text' => $LANG->line('path_conf')),
				'cell2' => array('class' => "tableCellTwo", 'text' => $LANG->line('path_conf_desc'),'colspan'=>"1"),
				));	
		// Upload Path									
		$field = $DSP->input_text('upload_path', ($this->config('upload_path'))?$this->config('upload_path'):'', null, null, null, $input_style);
		$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => $class, 'text' => $DSP->qdiv('defaultBold', $LANG->line('upload_path'))),
				'cell2' => array('class' => $class, 'text' => $DSP->qspan('default', $field)),
											));
		// Upload URL									
		$field = $DSP->input_text('upload_url', ($this->config('upload_url'))?$this->config('upload_url'):'', null, null, null, $input_style);
		$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => $class, 'text' => $DSP->qdiv('defaultBold', $LANG->line('upload_url'))),
				'cell2' => array('class' => $class, 'text' => $DSP->qspan('default', $field)),
											));

	/*hr*/$DSP->body .= $DSP->table_row(array('cell1' => array('text' => "&nbsp;",'colspan'=>"2")));
		$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => "tableHeading", 'width'=>"30%", 'text' => $LANG->line('resize_conf')),
				'cell2' => array('class' => "tableCellTwo", 'text' => $LANG->line('resize_conf_desc'),'colspan'=>"1"),
				));	
		// Original									
		$field = "W: ".$DSP->input_text('orig_w', ($this->config('orig_w'))?$this->config('orig_w'):'0', null, null, null, $input_style_wh);
		$field .= " &nbsp; &nbsp; H: ".$DSP->input_text('orig_h', ($this->config('orig_h'))?$this->config('orig_h'):'0', null, null, null, $input_style_wh);
		$field .= " &nbsp; &nbsp; ".$DSP->input_checkbox('orig_crop', 1, $this->config('orig_crop')?'y':'n')." Crop ";
		$field .= "<br /> &nbsp; &nbsp; ".$DSP->input_checkbox('orig_no_resize_up', 1, $this->config('orig_no_resize_up')?'y':'n')." ".$LANG->line('no_resize_up');
		$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => $class, 'text' => $DSP->qdiv('defaultBold', $LANG->line('orig_wh'))),
				'cell2' => array('class' => $class, 'text' => $DSP->qspan('default', $field)),
											));
		// Medium									
		$field = "W: ".$DSP->input_text('medium_w', ($this->config('medium_w'))?$this->config('medium_w'):'0', null, null, null, $input_style_wh);
		$field .= " &nbsp; &nbsp; H: ".$DSP->input_text('medium_h', ($this->config('medium_h'))?$this->config('medium_h'):'0', null, null, null, $input_style_wh);
		$field .= " &nbsp; &nbsp; ".$DSP->input_checkbox('medium_crop', 1, $this->config('medium_crop')?'y':'n')." Crop ";
		$field .= "<br /> &nbsp; &nbsp; ".$DSP->input_checkbox('medium_no_resize_up', 1, $this->config('medium_no_resize_up')?'y':'n')." ".$LANG->line('no_resize_up');
		$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => $class, 'text' => $DSP->qdiv('defaultBold', $LANG->line('medium_wh'))),
				'cell2' => array('class' => $class, 'text' => $DSP->qspan('default', $field)),
											));
		// Thumb									
		$field = "W: ".$DSP->input_text('thumb_w', ($this->config('thumb_w'))?$this->config('thumb_w'):'0', null, null, null, $input_style_wh);
		$field .= " &nbsp; &nbsp; H: ".$DSP->input_text('thumb_h', ($this->config('thumb_h'))?$this->config('thumb_h'):'0', null, null, null, $input_style_wh);
		$field .= " &nbsp; &nbsp; ".$DSP->input_checkbox('thumb_crop', 1, $this->config('thumb_crop')?'y':'n')." Crop ";
		$field .= "<br /> &nbsp; &nbsp; ".$DSP->input_checkbox('thumb_no_resize_up', 1, $this->config('thumb_no_resize_up')?'y':'n')." ".$LANG->line('no_resize_up');
		$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => $class, 'text' => $DSP->qdiv('defaultBold', $LANG->line('thumb_wh'))),
				'cell2' => array('class' => $class, 'text' => $DSP->qspan('default', $field)),
											));
		// Medium - name
		$field = $DSP->input_text('medium_name', ($this->config('medium_name'))?$this->config('medium_name'):'', null, null, null, $input_style);
		$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => $class, 'text' => $DSP->qdiv('defaultBold', $LANG->line('medium_name'))),
				'cell2' => array('class' => $class, 'text' => $DSP->qspan('default', $field)),
											));
		// Thumb - name
		$field = $DSP->input_text('thumb_name', ($this->config('thumb_name'))?$this->config('thumb_name'):'', null, null, null, $input_style);
		$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => $class, 'text' => $DSP->qdiv('defaultBold', $LANG->line('thumb_name'))),
				'cell2' => array('class' => $class, 'text' => $DSP->qspan('default', $field)),
											));
											
	/*hr*/$DSP->body .= $DSP->table_row(array('cell1' => array('text' => "&nbsp;",'colspan'=>"2")));
		$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => "tableHeadingAlt", 'width'=>"30%", 'text' => $DSP->input_submit($LANG->line('save'), 'save'),'colspan'=>"2"),
				));

		// Закрытие таблицы
		$DSP->body .= $DSP->table_close(FALSE);
		$DSP->body .= $DSP->form_c();
		$this->chunk_menu(0);
	}


	// ----------------------------------------
    //  Изменить параметры картинки - всплывающее окно
    // ----------------------------------------
	function modify_s()
	{
		global $DSP, $LANG, $DB, $IN, $PREFS;
		
		if( ! $IN->GBL('id') )
		{
			$DSP->body .= "ID not passed !";
			return '';
		}
		
        if( $IN->GBL('save') )
        {
        	$sql = "UPDATE exp_dc_gallery SET ";
        	$sql .= "title='".$IN->GBL('title', 'POST')."',";
        	$sql .= "description='".$IN->GBL('description', 'POST')."',";
        	$sql = substr($sql,0,-1);
			$DB->query("$sql WHERE image_id='".$IN->GBL('id')."'");
			$DSP->body .= "<script type='text/javascript'>\nwindow.close()\n</script>";
		}
		
		$img = $DB->query("SELECT image_id,filename,title,description FROM exp_dc_gallery WHERE image_id='".$IN->GBL('id')."'");

		if( $img->num_rows <= 0 )
		{
			$DSP->body .= "NOT FOUND !";
			return '';
		}
        
        // Заголовок таблицы
		$DSP->body .= $DSP->qdiv('tableHeading', $LANG->line('modify_image')." \"{$img->row['filename']} (#{$img->row['image_id']})\"");
		
		$DSP->body .= $DSP->form('C=modules'.AMP.'M=Dc_gallery'.AMP.'P=modify_s'.AMP.'Z=1'.AMP.'id='.$IN->GBL('id'), "modifyform");
		// Основная таблица
		$DSP->body .= $DSP->table_open(array('class' => "tableBorder", 'width' => "100%", 'valign' => "top"));

		$input_style = "295px;border:1px solid #CCCCCC;";
		$input_style_wh = "80px;border:1px solid #CCCCCC;";
		
		// TITLE
		$class = (0 % 2) ? "tableCellOne" : "tableCellTwo";
		$field = $DSP->input_text('title', $img->row['title'], null, null, null, $input_style);
		$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => $class, 'text' => $DSP->qdiv('defaultBold', $LANG->line('title'))),
				'cell2' => array('class' => $class, 'text' => $DSP->qspan('default', $field)),
											));
		
		// DESCRIPTION
		$class = (1 % 2) ? "tableCellOne" : "tableCellTwo";
		$field = $DSP->input_textarea('description', $img->row['description'], 5, null, $input_style);
		$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => $class, 'text' => $DSP->qdiv('defaultBold', $LANG->line('description'))),
				'cell2' => array('class' => $class, 'text' => $DSP->qspan('default', $field)),
											));

	/*hr*/$DSP->body .= $DSP->table_row(array('cell1' => array('text' => "&nbsp;",'colspan'=>"2")));
		$DSP->body .= $DSP->table_row(array(
				'cell1' => array('class' => "tableHeadingAlt", 'width'=>"30%", 'text' => $DSP->input_submit($LANG->line('save_modif'), 'save'),'colspan'=>"2"),
				));

		// Закрытие таблицы
		$DSP->body .= $DSP->table_close(FALSE);
		$DSP->body .= $DSP->form_c();
	}

    // ----------------------------------------
    //  Module installer
    // ----------------------------------------

    function Dc_gallery_module_install()
    {
        global $DB, $PREFS;        

        // Default settings:
        $site_id = $PREFS->ini('site_id');
		$this->settings[$site_id]['upload_path'] = str_replace($PREFS->ini('system_folder')."/", "", PATH)."images/uploads/{blog_name}/{entry_id}/";
		$this->settings[$site_id]['upload_url'] = $PREFS->ini('site_url')."images/uploads/{blog_name}/{entry_id}/";
		$this->settings[$site_id]['orig_w'] = "0";
		$this->settings[$site_id]['orig_h'] = "0";
		$this->settings[$site_id]['medium_w'] = "250";
		$this->settings[$site_id]['medium_h'] = "0";
		$this->settings[$site_id]['thumb_w'] = "90";
		$this->settings[$site_id]['thumb_h'] = "0";
		$this->settings[$site_id]['medium_name'] = "_medium";
		$this->settings[$site_id]['thumb_name'] = "_thumb";
        
		/*** /START/ Activate Extension ***/
		$methods = array(
			'set_form_enctype'		=> array(
										'class'        => 'Dc_gallery_ext',
										'method'       => 'set_form_enctype',
										'hook'         => 'form_declaration_modify_data',
										'settings'     => serialize($this->settings),
										'priority'     => 6,
										'version'      => $this->version,
										'enabled'      => 'y'
										),
			'gallery_tab'	=> array(
										'class'        => 'Dc_gallery_ext',
										'method'       => 'gallery_tab',
										'hook'         => 'publish_form_new_tabs',
										'settings'     => serialize($this->settings),
										'priority'     => 6,
										'version'      => $this->version,
										'enabled'      => 'y'
										),
			'gallery_tab_block'	=> array(
										'class'        => 'Dc_gallery_ext',
										'method'       => 'gallery_tab_block',
										'hook'         => 'publish_form_new_tabs_block',
										'settings'     => serialize($this->settings),
										'priority'     => 6,
										'version'      => $this->version,
										'enabled'      => 'y'
										),
			'save_start'		=> array(
										'class'        => 'Dc_gallery_ext',
										'method'       => 'save_start',
										'hook'         => 'submit_new_entry_start',
										'settings'     => serialize($this->settings),
										'priority'     => 6,
										'version'      => $this->version,
										'enabled'      => 'y'
										),
			'save'				=> array(
										'class'        => 'Dc_gallery_ext',
										'method'       => 'save',
										'hook'         => 'submit_new_entry_end',
										'settings'     => serialize($this->settings),
										'priority'     => 6,
										'version'      => $this->version,
										'enabled'      => 'y'
										)
		);
		foreach( $methods as $arr ) $DB->query($DB->insert_string('exp_extensions', $arr));
		/*** /END/ Activate Extension ***/
		
        $sql[] = "INSERT INTO exp_modules (module_id,
                                           module_name,
                                           module_version,
                                           has_cp_backend)
                                           VALUES
                                           ('',
                                           'Dc_gallery',
                                           '$this->version',
                                           'y')";
		$sql[] = "CREATE TABLE IF NOT EXISTS `exp_dc_gallery` (
						`image_id` int(11) unsigned NOT NULL auto_increment,
						`entry_id` int(10) unsigned NOT NULL default '0',
						`weblog_id` int(6) unsigned NOT NULL default '0',
						`cat_id` int(10) unsigned NOT NULL default '0',
						`filename` varchar(255) NOT NULL default '',
						`filename_medium` varchar(255) NOT NULL default '',
						`filename_thumb` varchar(255) NOT NULL default '',
						`wh_param` text default '',
						`order` int(4) unsigned NOT NULL default '0',
						`comment_total` int(4) unsigned default '0',
						`time` int(10),
						`title` varchar(255) NOT NULL default '',
						`description` text default '',
						PRIMARY KEY (`image_id`)
						)";
		
        foreach( $sql as $query ) $DB->query($query);
        
        return true;
    }
    // END
    
    
    // ----------------------------------------
    //  Module de-installer
    // ----------------------------------------

    function Dc_gallery_module_deinstall()
    {
        global $DB;    

		$sql[] = "DELETE FROM exp_extensions WHERE class='Dc_gallery_ext'";
        $sql[] = "DELETE FROM exp_modules WHERE module_name = 'Dc_gallery'";
		$sql[] = "DROP TABLE IF EXISTS exp_dc_gallery";

        foreach( $sql as $query ) $DB->query($query);

        return true;
    }
    // END
}
// END CLASS
?>